module ForteRuby
  module API
    class Objects < Base
      def all
        send_request(url, :get) do |response|
          parse_response(response)
        end
      end

      def build_from(params)
        single_class.new(params.merge(request_data: request_data, new: true))
      end

      def find_by_id(id)
        send_request(url + "/#{id}", :get) do |response|
          parse_response(response)
        end
      end

      def filter(params)
        filter_value = params.map{ |key, value| "#{key}+eq+#{value}"}.join("+and+")
        send_request(url + "?filter=#{filter_value}", :get) do |response|
          parse_response(response)
        end
      end

      protected

      def single_class
        raise 'Impelement it'
      end

      def url
        raise 'Impelement it'
      end

      private

      def parse_response(response)
        parsed_response = JSON.parse(response)
        if parsed_response['results']
          self.result = parsed_response['results'].map do |object_params| 
            single_class.new(object_params.merge(request_data: request_data))
          end
        else
          self.result = single_class.new(parsed_response)
        end
      end
    end
  end
end
