module ForteRuby
  module Resourses
    class Address < API::Object
      
      API_ATTRIBUTES = [
        :first_name, :last_name, :company_name, :phone, :fax, :email,
        :label, :address_type, :shipping_address_type, :physical_address
      ]

      API_ATTRIBUTES.each do |attribute|
        attr_accessor attribute
      end

      attr_accessor :customer_token, :address_token

      protected

      def url
        "#{request_data.base_url}/customers/#{customer_token}/addresses/#{address_token}"
      end
      
      def api_attributes
        API_ATTRIBUTES
      end
    end
  end
end
