module ForteRuby
  module Resourses
    class Customer < API::Object
      
      API_ATTRIBUTES = [
        :customer_token, :customer_id, :default_paymethod_token, :default_billing_address_token, :default_shipping_address_token,
        :status, :last_name, :first_name, :company_name, :paymethod
      ]

      API_ATTRIBUTES.each do |attribute|
        attr_accessor attribute
      end

      def addresses
        Addresses.new(request_data: request_data, customer_token: customer_token)
      end

      protected

      def url
        "#{request_data.base_url}/customers/#{customer_token}"
      end
      
      def api_attributes
        API_ATTRIBUTES
      end
    end
  end
end
