module ForteRuby
  module Resourses
    class Settlement < API::Object
      
      API_ATTRIBUTES = [
        :customer_token, :customer_id, :order_number, :reference_id, :settle_id, :transaction_id, :settle_date, :settle_type,
        :settle_response_code, :settle_amount, :method
      ]

      API_ATTRIBUTES.each do |attribute|
        attr_accessor attribute
      end

      COMPLETED_RESPONSE_CODE = 'A01'

      def delete
        raise 'It is not implemented'
      end

      def update
        raise 'It is not implemented'
      end

      def save
        raise 'It is not implemented'
      end

      def status
        if response_code == COMPLETED_RESPONSE_CODE
          'completed'
        else
          'declined'
        end
      end

      protected
      
      def api_attributes
        API_ATTRIBUTES
      end
    end
  end
end
